import uno
import unohelper
import datetime
from hdm360.calcfunction.addin import XLunar

class LunarImpl( unohelper.Base, XLunar ):

    def __init__( self, ctx ):
        self.ctx = ctx

    def lunar( self, nDate, nMode):
        if nMode == 0:
            kijunbi = datetime.date(1899, 12, 30)
        elif nMode == 1:
            kijunbi = datetime.date(1900, 1, 1)
        elif nMode == 2:
            kijunbi = datetime.date(1904, 1, 1)
        else:
            kijunbi = datetime.date(1899, 12, 30)
        
        d = kijunbi + datetime.timedelta(nDate)
        
        Y = d.year
        M = d.month
        D = d.day
        C = (((Y - 2009) % 19) * 11 + M + D) % 30
        return C

def createInstance( ctx ):
    return LunarImpl( ctx )

g_ImplementationHelper = unohelper.ImplementationHelper()

g_ImplementationHelper.addImplementation( \
    createInstance,"hdm360.calcfunction.addin.python.LunarImpl",
    ("com.sun.star.sheet.AddIn",),)
    